# ***************************************************************************
# Ceci est le squelette du fichier dans lequel *toutes* vos fonctions doivent 
# etre ecrites. Il a ete quelque peu adapte pour vous permettre d'executer des 
# tests automatiquement et sans effort: il suffira de decommenter la ligne if 
# if __name__ == '__main__': testeur.fais_tests('...') 
# presente apres chaque definition de fonction.
#
# ***ATTENTION*** Pour que cela fonctionne bien dans pyzo, il est 
# ***absolument primordial*** de lancer l'execution dans le menu via 
# "Executer  en tant que script" ou "Run file as script"
# c'est-a-dire avec le raccourci Ctrl-Shift-E (et NON simplement Ctrl-E) sinon 
# les mises a jour de votre fichier ne seront pas prises en compte.
# (NB: Si vous etes sous Mac, c'est Pomme-Shift-E qu'il faut utiliser)
# ***************************************************************************


# Ne **JAMAIS** commenter la ligne suivante...
if __name__ == '__main__': import test_DM_RLC as testeur


# ***************************************************************************
# Lecture du fichier
# ***************************************************************************

def lecture(fichier):
    """ Procedure de lecture du fichier. fichier est la chaine de caracteres 
    permettant a la fonction de trouver le fichier concerne. Ce fichier est de la forme
       Temps;EA1
       0;3,20434744656086
       6E-7;2,92130423337221
    Il faut donc:
    * ignorer la ligne commencant par 'Temps'
    * changer les virgules en points
    * splitter chaque ligne en utilisant ';' comme separateur    
    * stocker les infos dans deux listes en pensant bien a les convertir en 
    flottant avant le stockage.
    NB: ne pas oublier de fermer le descripteur de fichier avec un close() une 
    fois la lecture effectuee.
    """
    return temps,tensions


# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('01_lecture_fichier')


# ***************************************************************************
# Annulations
# ***************************************************************************

def points_d_annulation(tensions,gap=10):
    """ Etant donnee la liste des tensions, trouve la liste des positions i 
    dans cette liste telles que
    * tensions[i] et tensions[i+1] soient de signes contraire
    * deux annulations successives soient au moins separees de gap indices 
    (valeur par defaut a 10)
    """
    return liste_position_zeros

# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('02_annulations')

# ***************************************************************************
# Maxima successifs
# ***************************************************************************

def maxima_successifs(tensions):
    """ Etant donnee la liste des tensions, trouve la liste des positions i de 
    passage par un maximum. On considere qu'on trouvera un seul maximum entre 
    la premiere et la troisieme annulation, puis entre la troisieme et la 
    cinquieme, puis... Si le maximum est atteint plusieurs fois sur une 
    pseudo-periode, on prendra l'indice le plus petit qui l'atteigne.
    NB: vous *devez* utiliser votre fonction points_d_annulation precedente"""
    return liste_position_maxima

# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('03_maxima_successifs')

# ***************************************************************************
# Pseudo-periode par methode des zeros
# ***************************************************************************

def pseudo_periode_par_zeros(temps,tensions,nmax=10):
    """ La pseudo-periode correspond a l'intervalle de temps entre deux zeros 
    traverses "dans le meme sens". Pour ne pas etre gene par le "bruit" de la 
    fin du signal, on se contentera d'une moyenne sur nmax pseudo-periodes au 
    maximum (ou on prend par defaut nmax=10).
    NB: vous *devez* utiliser votre fonction points_d_annulation precedente"""
    return T

# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('04_T_par_zeros')

# ***************************************************************************
# Pseudo-periode par methode des maxima
# ***************************************************************************

def pseudo_periode_par_maxima(temps,tensions,nmax=10):
    """ La pseudo-periode vaut aussi (a peu pres) l'intervalle de temps entre 
    deux maxima consecutifs. De meme que precedemment, pour ne pas etre gene 
    par le "bruit" de la fin du signal, on se contentera d'une moyenne sur 
    nmax pseudo-periodes au maximum (ou on prend par defaut nmax=10).
    NB: vous *devez* utiliser votre fonction maxima_successifs precedente"""
    return T

# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('05_T_par_maxima')

# ***************************************************************************
# Decrement logarithmique
# ***************************************************************************

import math  # Import du module math pour le logarithme

def decrement_logarithmique(tensions):
    """ Determination du decrement logarithmique a partir de la connaissance 
    des maxima de la fontion. On prendra pour le calculer les premier et 
    quatrieme maxima du signal.
    NB: vous *devez* utiliser votre fonction maxima_successifs precedente."""
    return decrement

# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('06_decrement_logarithmique')

# ***************************************************************************
# Facteur de qualite et pulsation propre
# ***************************************************************************

def Q_et_w0(temps,tensions):
    """ Calcul du facteur de qualite Q et de la pulsation propre w0 a partir 
    des calculs deja effectues precedemment (notamment la fonction 
    decrement_logarithmique et la fonction pseudo_periode_par_zeros). """
    return Q,w0

# Ligne suivante a decommenter pour tester 
#if __name__ == '__main__': testeur.fais_tests('07_Q_et_w0')



# Calcul de la note finale
if __name__ == '__main__': testeur.detaille_note()
